package MT::Plugin::PageRating;
;#	MTPageRating - y[W]AP[ggݍ MovableType vOC
;#	@see http://www.magicvox.net/archive/2005/08231358.php
;#			Programmed by Piroli YUKARINOMIYA
;#			Open MagicVox - http://www.magicvox.net
use strict;
use MT::Template::Context;

;# vOCo^
if (MT->can ('add_plugin'))
{
	require MT::Plugin;
	my $plugin = MT::Plugin->new;
		$plugin->name ('MTPageRating ver 0.10 (Release 823)');
		$plugin->description ('Set up the questionnaires form on each entry page.');
		$plugin->doc_link ('http://www.magicvox.net/archive/2005/08231358.php');
	MT->add_plugin ($plugin);
}

;# nho^
MT::Template::Context->add_tag (UsePageRating => \&use_page_rating);
MT::Template::Context->add_container_tag (PageRatingDone => \&page_rating_done);
MT::Template::Context->add_container_tag (PageRating => \&page_rating);
MT::Template::Context->add_tag (PageRatingItem => \&page_rating_item);
MT::Template::Context->add_tag (PageRatingComment => \&page_rating_comment);
MT::Template::Context->add_tag (PageRatingSubmit => \&page_rating_submit);



;########################################################################

;### MTUsePageRating
;### ex.) path="/home/your/account/data/rating" name="hogehoge" type="0"
sub use_page_rating
{
    my ($ctx, $args) = @_;

	;### f[^t@C̃pX
	my $path;
	$path = $args->{'path'} if ($args && $args->{'path'});
	return $ctx->error ('MTUsePageRating - sȃpXw') if ($path =~ /[^\w-\/\\]/);
	$path = '.' if ($path eq '');
	my $name = 'default';
	$name = $args->{'name'} if ($args && $args->{'name'});
	return $ctx->error ('MTUsePageRating - sȃt@Cw') if ($name =~ /[^\w-]/);
	$path .= '/'. $name;

	;### f[^t@C̃^Cv
	my $type = 0;
	$type = int ($args->{'type'}) if ($args && $args->{'type'});

	;### Gg
	my $entry = $ctx->stash ('entry')
			or return $ctx->_no_entry_error ('MTPageRating');

	my $php = <<'__PHPHEREDOCUMENT__';
////////////////////////////////////////////////////////////////////////
// MTPageRating - y[W]AP[ggݍ MovableType vOC
// @see http://www.magicvox.net/archive/2005/08231358.php
$g_isPageRatingDone = 0;
function isPageRatingDone () { global $g_isPageRatingDone; return ($g_isPageRatingDone); }
function PageRatingSubmit ($path, $type, $id) {
	// NG
	if (! array_key_exists ('rating', $_POST))
		return;
	// Ot@C
	$nCurTime = time ();
	if ($type == 1) {
		if (! is_dir ($path))
			return;
		$path .= date ("Ym", $nCurTime). ".log";
	} else if ($type == 2) {
		if (! is_dir ($path))
			return;
		$path .= date ("Ymd", $nCurTime). ".log";
	} else {
		$path .= ".log";
		if (! is_file ($path))
			return;
	}
	// f[^\z
	$dat = date ("Y/m/d H:i:s", $nCurTime). "\t". $_SERVER['REMOTE_ADDR']. "\t". $id. "\t". $_POST['rating'];
	if (array_key_exists ('comment', $_POST))
		$dat .= "\t". $_POST['comment'];
	$dat .= "\r\n";
	// t@Cɏo
	if ($fh = fopen ($path, "a+")) {
		if (flock ($fh, LOCK_EX)) {
			fputs ($fh, $dat);
			flock ($fh, LOCK_UN);
		}
		fclose ($fh);
	}
	// ]ς
	global $g_isPageRatingDone;
	$g_isPageRatingDone = 1;
}
__PHPHEREDOCUMENT__

	$php .= 'PageRatingSubmit ("'. $path. '", '. $type. ', '. $entry->id. ');';
	"<?php\r\n". $php. "\r\n?>";
}

;### MTPageRatingDone
sub page_rating_done
{
	my ($ctx, $args, $cond) = @_;

	my $builder = $ctx->stash ('builder');
	my $tokens = $ctx->stash ('tokens');
	my $out = $builder->build ($ctx, $tokens, $cond);
	return $ctx->error ($builder->errstr)
			unless defined $out;

	'<?php if (isPageRatingDone ()) { ?>'. $out. '<?php } ?>';
}

;### MTPageRating (enable attributes are id, class, style)
sub page_rating
{
	my ($ctx, $args, $cond) = @_;

	my $builder = $ctx->stash ('builder');
	my $tokens = $ctx->stash ('tokens');
	my $out = $builder->build ($ctx, $tokens, $cond);
	return $ctx->error ($builder->errstr)
			unless defined $out;

	my $html = '<form method="POST"';
	$html .= ' id="'. $args->{'id'}. '"'
			if ($args && defined $args->{'id'});
	$html .= ' class="'. $args->{'class'}. '"'
			if ($args && defined $args->{'class'});
	$html .= ' style="'. $args->{'style'}. '"'
			if ($args && defined $args->{'style'});
	$html .= ">\r\n". $out. "</form>";

	'<?php if (! isPageRatingDone ()) { ?>'. $html. '<?php } ?>';
}

;### MTPageRatingItem (enable attributes are id, class, style, value, tabindex, accesskey, default)
sub page_rating_item
{
    my ($ctx, $args) = @_;

	my $html = '<input type="radio" name="rating"';
	$html .= ' id="'. $args->{'id'}. '"'
			if ($args && defined $args->{'id'});
	$html .= ' class="'. $args->{'class'}. '"'
			if ($args && defined $args->{'class'});
	$html .= ' style="'. $args->{'style'}. '"'
			if ($args && defined $args->{'style'});
	$html .= ' value="'. $args->{'value'}. '"'
			if ($args && defined $args->{'value'});
	$html .= ' tabindex="'. $args->{'tabindex'}. '"'
			if ($args && defined $args->{'tabindex'});
	$html .= ' accesskey="'. $args->{'accesskey'}. '"'
			if ($args && defined $args->{'accesskey'});
	$html .= ' checked'
			if ($args && defined $args->{'default'});
	$html. '>';
}

;### MTPageRatingComment (enable attributes are id, class, style, value, tabindex, accesskey, size)
sub page_rating_comment
{
    my ($ctx, $args) = @_;

	my $html = '<input type="text" name="comment"';
	$html .= ' id="'. $args->{'id'}. '"'
			if ($args && defined $args->{'id'});
	$html .= ' class="'. $args->{'class'}. '"'
			if ($args && defined $args->{'class'});
	$html .= ' style="'. $args->{'style'}. '"'
			if ($args && defined $args->{'style'});
	$html .= ' value="'. $args->{'value'}. '"'
			if ($args && defined $args->{'value'});
	$html .= ' tabindex="'. $args->{'tabindex'}. '"'
			if ($args && defined $args->{'tabindex'});
	$html .= ' accesskey="'. $args->{'accesskey'}. '"'
			if ($args && defined $args->{'accesskey'});
	$html .= ' size="'. $args->{'size'}. '"'
			if ($args && defined $args->{'size'});
	$html. '>';
}

;### MTPageRatingSubmit (enable attributes are id, class, style, value, tabindex, accesskey)
sub page_rating_submit
{
    my ($ctx, $args) = @_;

	my $html = '<input type="submit"';
	$html .= ' id="'. $args->{'id'}. '"'
			if ($args && defined $args->{'id'});
	$html .= ' class="'. $args->{'class'}. '"'
			if ($args && defined $args->{'class'});
	$html .= ' style="'. $args->{'style'}. '"'
			if ($args && defined $args->{'style'});
	$html .= ' value="'. $args->{'value'}. '"'
			if ($args && defined $args->{'value'});
	$html .= ' tabindex="'. $args->{'tabindex'}. '"'
			if ($args && defined $args->{'tabindex'});
	$html .= ' accesskey="'. $args->{'accesskey'}. '"'
			if ($args && defined $args->{'accesskey'});
	$html. '>';
}



1;
__END__
========================================================================
2005/08/23	0.10	ŌJ
